// GENERATED CODE - DO NOT MODIFY BY HAND
// This code was generated by ObjectBox. To update it run the generator again:
// With a Flutter package, run `flutter pub run build_runner build`.
// With a Dart package, run `dart run build_runner build`.
// See also https://docs.objectbox.io/getting-started#generate-objectbox-code

// ignore_for_file: camel_case_types, depend_on_referenced_packages
// coverage:ignore-file

import 'dart:typed_data';

import 'package:flat_buffers/flat_buffers.dart' as fb;
import 'package:objectbox/internal.dart'; // generated code can access "internal" functionality
import 'package:objectbox/objectbox.dart';
import 'package:objectbox_flutter_libs/objectbox_flutter_libs.dart';

import 'object/day.dart';
import 'object/frozenMeal.dart';
import 'object/history.dart';
import 'object/ingredient.dart';
import 'object/recipe.dart';
import 'object/shop.dart';
import 'object/shoppingList.dart';
import 'object/tag.dart';
import 'object/unit.dart';

export 'package:objectbox/objectbox.dart'; // so that callers only have to import this file

final _entities = <ModelEntity>[
  ModelEntity(
      id: const IdUid(1, 4382716501522006062),
      name: 'Day',
      lastPropertyId: const IdUid(5, 1595249142842006405),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 1131346516474868371),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 3868197222127195706),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(1, 5429278345644092691)),
        ModelProperty(
            id: const IdUid(3, 5884064649925415088),
            name: 'date',
            type: 10,
            flags: 0),
        ModelProperty(
            id: const IdUid(4, 3499507570603285363),
            name: 'dbLunchMenu',
            type: 30,
            flags: 0),
        ModelProperty(
            id: const IdUid(5, 1595249142842006405),
            name: 'dbDinnerMenu',
            type: 30,
            flags: 0)
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(2, 1914605603859975030),
      name: 'FrozenMeal',
      lastPropertyId: const IdUid(6, 1623659635430558470),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 51304023992839042),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 2988983998456100054),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(2, 7028890397633977124)),
        ModelProperty(
            id: const IdUid(3, 9215739000608878267),
            name: 'name',
            type: 9,
            flags: 2080,
            indexId: const IdUid(3, 8422701449179562943)),
        ModelProperty(
            id: const IdUid(4, 2923452142086065338),
            name: 'freezingDate',
            type: 10,
            flags: 0),
        ModelProperty(
            id: const IdUid(5, 155997143082619876),
            name: 'quantity',
            type: 6,
            flags: 0),
        ModelProperty(
            id: const IdUid(6, 1623659635430558470),
            name: 'coversType',
            type: 9,
            flags: 0)
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(3, 3771739892032175123),
      name: 'History',
      lastPropertyId: const IdUid(5, 2612685651328029347),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 1668691557931595939),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 7771802393993497566),
            name: 'objectName',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(3, 8841770452350347716),
            name: 'uuid',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(4, 5716616999600430790),
            name: 'dateTime',
            type: 10,
            flags: 0),
        ModelProperty(
            id: const IdUid(5, 2612685651328029347),
            name: 'operation',
            type: 9,
            flags: 0)
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(4, 8898209934432506918),
      name: 'Ingredient',
      lastPropertyId: const IdUid(5, 659344526851713875),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 5102100533031317535),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 5013275554649112366),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(4, 7730327366826920948)),
        ModelProperty(
            id: const IdUid(3, 6244163873174634436),
            name: 'name',
            type: 9,
            flags: 2080,
            indexId: const IdUid(5, 2466957902989281045)),
        ModelProperty(
            id: const IdUid(4, 2544303781818106137),
            name: 'icon',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(5, 659344526851713875),
            name: 'shopId',
            type: 11,
            flags: 520,
            indexId: const IdUid(6, 5482131189237600889),
            relationTarget: 'Shop')
      ],
      relations: <ModelRelation>[
        ModelRelation(
            id: const IdUid(1, 1721311861684005118),
            name: 'units',
            targetId: const IdUid(9, 8395371506019534955))
      ],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(5, 269445234759077125),
      name: 'Recipe',
      lastPropertyId: const IdUid(17, 787992129561628852),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 8587017946162596678),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 3119101536650080034),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(7, 6292790139058131757)),
        ModelProperty(
            id: const IdUid(3, 7889424240394744229),
            name: 'name',
            type: 9,
            flags: 2080,
            indexId: const IdUid(8, 2442025366690044116)),
        ModelProperty(
            id: const IdUid(4, 250345258540537657),
            name: 'defaultQuantity',
            type: 6,
            flags: 0),
        ModelProperty(
            id: const IdUid(5, 3759726236107432513),
            name: 'coversType',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(6, 7106210798237751468),
            name: 'difficultyLevel',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(7, 9099599964044962837),
            name: 'healthinessLevel',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(8, 6914170317025601461),
            name: 'approvalStatus',
            type: 1,
            flags: 0),
        ModelProperty(
            id: const IdUid(9, 828190974508127068),
            name: 'mealTypesList',
            type: 30,
            flags: 0),
        ModelProperty(
            id: const IdUid(10, 3077851300027496007),
            name: 'lastCookingDate',
            type: 10,
            flags: 0),
        ModelProperty(
            id: const IdUid(11, 2506201571190486602),
            name: 'creationDate',
            type: 10,
            flags: 0),
        ModelProperty(
            id: const IdUid(12, 4539493066490997780),
            name: 'picturePaths',
            type: 30,
            flags: 0),
        ModelProperty(
            id: const IdUid(13, 2385173535272824427),
            name: 'dbPreparationDuration',
            type: 6,
            flags: 0),
        ModelProperty(
            id: const IdUid(14, 4064551136282634468),
            name: 'dbCookingDuration',
            type: 6,
            flags: 0),
        ModelProperty(
            id: const IdUid(15, 1781858909649337737),
            name: 'dbBreakDuration',
            type: 6,
            flags: 0),
        ModelProperty(
            id: const IdUid(16, 1301595790537385966),
            name: 'dbSeason',
            type: 30,
            flags: 0),
        ModelProperty(
            id: const IdUid(17, 787992129561628852),
            name: 'dbSectionsList',
            type: 30,
            flags: 0)
      ],
      relations: <ModelRelation>[
        ModelRelation(
            id: const IdUid(2, 6216148340557258253),
            name: 'tags',
            targetId: const IdUid(8, 743758044048262114))
      ],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(6, 9026932078150722888),
      name: 'Shop',
      lastPropertyId: const IdUid(3, 8499563253919869724),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 6461127960355516050),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 3003940837827238179),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(9, 3333474308299851797)),
        ModelProperty(
            id: const IdUid(3, 8499563253919869724),
            name: 'name',
            type: 9,
            flags: 2080,
            indexId: const IdUid(10, 8377490825783607649))
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(7, 8279173550670063534),
      name: 'ShoppingList',
      lastPropertyId: const IdUid(5, 7428736278671001494),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 434609185146741602),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 6205580106256922862),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(11, 5037052004553715822)),
        ModelProperty(
            id: const IdUid(3, 6996232095755307585),
            name: 'start',
            type: 10,
            flags: 0),
        ModelProperty(
            id: const IdUid(4, 1709116115828212501),
            name: 'end',
            type: 10,
            flags: 0),
        ModelProperty(
            id: const IdUid(5, 7428736278671001494),
            name: 'dbItemsList',
            type: 30,
            flags: 0)
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(8, 743758044048262114),
      name: 'Tag',
      lastPropertyId: const IdUid(3, 7976874462026137896),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 5076518727572900571),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 6985090864884721651),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(12, 2211378599496700368)),
        ModelProperty(
            id: const IdUid(3, 7976874462026137896),
            name: 'name',
            type: 9,
            flags: 2080,
            indexId: const IdUid(13, 827879647082930962))
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[]),
  ModelEntity(
      id: const IdUid(9, 8395371506019534955),
      name: 'Unit',
      lastPropertyId: const IdUid(3, 6291232569047301271),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 7242629899362249159),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 3259827848531919807),
            name: 'uuid',
            type: 9,
            flags: 2080,
            indexId: const IdUid(14, 141245957422873411)),
        ModelProperty(
            id: const IdUid(3, 6291232569047301271),
            name: 'name',
            type: 9,
            flags: 2080,
            indexId: const IdUid(15, 2137791048882517418))
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[])
];

/// Open an ObjectBox store with the model declared in this file.
Future<Store> openStore(
        {String? directory,
        int? maxDBSizeInKB,
        int? fileMode,
        int? maxReaders,
        bool queriesCaseSensitiveDefault = true,
        String? macosApplicationGroup}) async =>
    Store(getObjectBoxModel(),
        directory: directory ?? (await defaultStoreDirectory()).path,
        maxDBSizeInKB: maxDBSizeInKB,
        fileMode: fileMode,
        maxReaders: maxReaders,
        queriesCaseSensitiveDefault: queriesCaseSensitiveDefault,
        macosApplicationGroup: macosApplicationGroup);

/// ObjectBox model definition, pass it to [Store] - Store(getObjectBoxModel())
ModelDefinition getObjectBoxModel() {
  final model = ModelInfo(
      entities: _entities,
      lastEntityId: const IdUid(9, 8395371506019534955),
      lastIndexId: const IdUid(15, 2137791048882517418),
      lastRelationId: const IdUid(2, 6216148340557258253),
      lastSequenceId: const IdUid(0, 0),
      retiredEntityUids: const [],
      retiredIndexUids: const [],
      retiredPropertyUids: const [],
      retiredRelationUids: const [],
      modelVersion: 5,
      modelVersionParserMinimum: 5,
      version: 1);

  final bindings = <Type, EntityDefinition>{
    Day: EntityDefinition<Day>(
        model: _entities[0],
        toOneRelations: (Day object) => [],
        toManyRelations: (Day object) => {},
        getId: (Day object) => object.id,
        setId: (Day object, int id) {
          object.id = id;
        },
        objectToFB: (Day object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final dbLunchMenuOffset = fbb.writeList(
              object.dbLunchMenu.map(fbb.writeString).toList(growable: false));
          final dbDinnerMenuOffset = fbb.writeList(
              object.dbDinnerMenu.map(fbb.writeString).toList(growable: false));
          fbb.startTable(6);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addInt64(2, object.date.millisecondsSinceEpoch);
          fbb.addOffset(3, dbLunchMenuOffset);
          fbb.addOffset(4, dbDinnerMenuOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = Day(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              date: DateTime.fromMillisecondsSinceEpoch(
                  const fb.Int64Reader().vTableGet(buffer, rootOffset, 8, 0)))
            ..dbLunchMenu = const fb.ListReader<String>(
                    fb.StringReader(asciiOptimization: true),
                    lazy: false)
                .vTableGet(buffer, rootOffset, 10, [])
            ..dbDinnerMenu = const fb.ListReader<String>(
                    fb.StringReader(asciiOptimization: true),
                    lazy: false)
                .vTableGet(buffer, rootOffset, 12, []);

          return object;
        }),
    FrozenMeal: EntityDefinition<FrozenMeal>(
        model: _entities[1],
        toOneRelations: (FrozenMeal object) => [],
        toManyRelations: (FrozenMeal object) => {},
        getId: (FrozenMeal object) => object.id,
        setId: (FrozenMeal object, int id) {
          object.id = id;
        },
        objectToFB: (FrozenMeal object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final nameOffset = fbb.writeString(object.name);
          final coversTypeOffset = fbb.writeString(object.coversType);
          fbb.startTable(7);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addOffset(2, nameOffset);
          fbb.addInt64(3, object.freezingDate.millisecondsSinceEpoch);
          fbb.addInt64(4, object.quantity);
          fbb.addOffset(5, coversTypeOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = FrozenMeal(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              name: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 8, ''),
              freezingDate: DateTime.fromMillisecondsSinceEpoch(
                  const fb.Int64Reader().vTableGet(buffer, rootOffset, 10, 0)),
              quantity:
                  const fb.Int64Reader().vTableGet(buffer, rootOffset, 12, 0),
              coversType: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 14, ''));

          return object;
        }),
    History: EntityDefinition<History>(
        model: _entities[2],
        toOneRelations: (History object) => [],
        toManyRelations: (History object) => {},
        getId: (History object) => object.id,
        setId: (History object, int id) {
          object.id = id;
        },
        objectToFB: (History object, fb.Builder fbb) {
          final objectNameOffset = fbb.writeString(object.objectName);
          final uuidOffset = fbb.writeString(object.uuid);
          final operationOffset = fbb.writeString(object.operation);
          fbb.startTable(6);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, objectNameOffset);
          fbb.addOffset(2, uuidOffset);
          fbb.addInt64(3, object.dateTime.millisecondsSinceEpoch);
          fbb.addOffset(4, operationOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = History(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              objectName: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 8, ''),
              dateTime: DateTime.fromMillisecondsSinceEpoch(
                  const fb.Int64Reader().vTableGet(buffer, rootOffset, 10, 0)),
              operation: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 12, ''));

          return object;
        }),
    Ingredient: EntityDefinition<Ingredient>(
        model: _entities[3],
        toOneRelations: (Ingredient object) => [object.shop],
        toManyRelations: (Ingredient object) =>
            {RelInfo<Ingredient>.toMany(1, object.id): object.units},
        getId: (Ingredient object) => object.id,
        setId: (Ingredient object, int id) {
          object.id = id;
        },
        objectToFB: (Ingredient object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final nameOffset = fbb.writeString(object.name);
          final iconOffset = fbb.writeString(object.icon);
          fbb.startTable(6);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addOffset(2, nameOffset);
          fbb.addOffset(3, iconOffset);
          fbb.addInt64(4, object.shop.targetId);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = Ingredient(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              name: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 8, ''),
              icon: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 10, ''));
          object.shop.targetId =
              const fb.Int64Reader().vTableGet(buffer, rootOffset, 12, 0);
          object.shop.attach(store);
          InternalToManyAccess.setRelInfo<Ingredient>(
              object.units, store, RelInfo<Ingredient>.toMany(1, object.id));
          return object;
        }),
    Recipe: EntityDefinition<Recipe>(
        model: _entities[4],
        toOneRelations: (Recipe object) => [],
        toManyRelations: (Recipe object) =>
            {RelInfo<Recipe>.toMany(2, object.id): object.tags},
        getId: (Recipe object) => object.id,
        setId: (Recipe object, int id) {
          object.id = id;
        },
        objectToFB: (Recipe object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final nameOffset = fbb.writeString(object.name);
          final coversTypeOffset = fbb.writeString(object.coversType);
          final difficultyLevelOffset = fbb.writeString(object.difficultyLevel);
          final healthinessLevelOffset =
              fbb.writeString(object.healthinessLevel);
          final mealTypesListOffset = fbb.writeList(object.mealTypesList
              .map(fbb.writeString)
              .toList(growable: false));
          final picturePathsOffset = fbb.writeList(
              object.picturePaths.map(fbb.writeString).toList(growable: false));
          final dbSeasonOffset = fbb.writeList(
              object.dbSeason.map(fbb.writeString).toList(growable: false));
          final dbSectionsListOffset = fbb.writeList(object.dbSectionsList
              .map(fbb.writeString)
              .toList(growable: false));
          fbb.startTable(18);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addOffset(2, nameOffset);
          fbb.addInt64(3, object.defaultQuantity);
          fbb.addOffset(4, coversTypeOffset);
          fbb.addOffset(5, difficultyLevelOffset);
          fbb.addOffset(6, healthinessLevelOffset);
          fbb.addBool(7, object.approvalStatus);
          fbb.addOffset(8, mealTypesListOffset);
          fbb.addInt64(9, object.lastCookingDate?.millisecondsSinceEpoch);
          fbb.addInt64(10, object.creationDate?.millisecondsSinceEpoch);
          fbb.addOffset(11, picturePathsOffset);
          fbb.addInt64(12, object.dbPreparationDuration);
          fbb.addInt64(13, object.dbCookingDuration);
          fbb.addInt64(14, object.dbBreakDuration);
          fbb.addOffset(15, dbSeasonOffset);
          fbb.addOffset(16, dbSectionsListOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);
          final lastCookingDateValue =
              const fb.Int64Reader().vTableGetNullable(buffer, rootOffset, 22);
          final creationDateValue =
              const fb.Int64Reader().vTableGetNullable(buffer, rootOffset, 24);
          final object = Recipe(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              name: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 8, ''),
              defaultQuantity:
                  const fb.Int64Reader().vTableGet(buffer, rootOffset, 10, 0),
              coversType: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 12, ''),
              difficultyLevel: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 14, ''),
              healthinessLevel: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 16, ''),
              approvalStatus: const fb.BoolReader()
                  .vTableGet(buffer, rootOffset, 18, false),
              mealTypesList: const fb.ListReader<String>(fb.StringReader(asciiOptimization: true), lazy: false)
                  .vTableGet(buffer, rootOffset, 20, []),
              lastCookingDate:
                  lastCookingDateValue == null ? null : DateTime.fromMillisecondsSinceEpoch(lastCookingDateValue),
              creationDate: creationDateValue == null ? null : DateTime.fromMillisecondsSinceEpoch(creationDateValue),
              picturePaths: const fb.ListReader<String>(fb.StringReader(asciiOptimization: true), lazy: false).vTableGet(buffer, rootOffset, 26, []))
            ..dbPreparationDuration =
                const fb.Int64Reader().vTableGet(buffer, rootOffset, 28, 0)
            ..dbCookingDuration =
                const fb.Int64Reader().vTableGet(buffer, rootOffset, 30, 0)
            ..dbBreakDuration =
                const fb.Int64Reader().vTableGet(buffer, rootOffset, 32, 0)
            ..dbSeason = const fb.ListReader<String>(
                    fb.StringReader(asciiOptimization: true),
                    lazy: false)
                .vTableGet(buffer, rootOffset, 34, [])
            ..dbSectionsList = const fb.ListReader<String>(fb.StringReader(asciiOptimization: true), lazy: false).vTableGet(buffer, rootOffset, 36, []);
          InternalToManyAccess.setRelInfo<Recipe>(
              object.tags, store, RelInfo<Recipe>.toMany(2, object.id));
          return object;
        }),
    Shop: EntityDefinition<Shop>(
        model: _entities[5],
        toOneRelations: (Shop object) => [],
        toManyRelations: (Shop object) => {},
        getId: (Shop object) => object.id,
        setId: (Shop object, int id) {
          object.id = id;
        },
        objectToFB: (Shop object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final nameOffset = fbb.writeString(object.name);
          fbb.startTable(4);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addOffset(2, nameOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = Shop(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              name: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 8, ''));

          return object;
        }),
    ShoppingList: EntityDefinition<ShoppingList>(
        model: _entities[6],
        toOneRelations: (ShoppingList object) => [],
        toManyRelations: (ShoppingList object) => {},
        getId: (ShoppingList object) => object.id,
        setId: (ShoppingList object, int id) {
          object.id = id;
        },
        objectToFB: (ShoppingList object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final dbItemsListOffset = fbb.writeList(
              object.dbItemsList.map(fbb.writeString).toList(growable: false));
          fbb.startTable(6);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addInt64(2, object.start.millisecondsSinceEpoch);
          fbb.addInt64(3, object.end.millisecondsSinceEpoch);
          fbb.addOffset(4, dbItemsListOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = ShoppingList(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              start: DateTime.fromMillisecondsSinceEpoch(
                  const fb.Int64Reader().vTableGet(buffer, rootOffset, 8, 0)),
              end: DateTime.fromMillisecondsSinceEpoch(
                  const fb.Int64Reader().vTableGet(buffer, rootOffset, 10, 0)))
            ..dbItemsList = const fb.ListReader<String>(
                    fb.StringReader(asciiOptimization: true),
                    lazy: false)
                .vTableGet(buffer, rootOffset, 12, []);

          return object;
        }),
    Tag: EntityDefinition<Tag>(
        model: _entities[7],
        toOneRelations: (Tag object) => [],
        toManyRelations: (Tag object) => {},
        getId: (Tag object) => object.id,
        setId: (Tag object, int id) {
          object.id = id;
        },
        objectToFB: (Tag object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final nameOffset = fbb.writeString(object.name);
          fbb.startTable(4);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addOffset(2, nameOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = Tag(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              name: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 8, ''));

          return object;
        }),
    Unit: EntityDefinition<Unit>(
        model: _entities[8],
        toOneRelations: (Unit object) => [],
        toManyRelations: (Unit object) => {},
        getId: (Unit object) => object.id,
        setId: (Unit object, int id) {
          object.id = id;
        },
        objectToFB: (Unit object, fb.Builder fbb) {
          final uuidOffset = fbb.writeString(object.uuid);
          final nameOffset = fbb.writeString(object.name);
          fbb.startTable(4);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, uuidOffset);
          fbb.addOffset(2, nameOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);

          final object = Unit(
              id: const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0),
              uuid: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 6, ''),
              name: const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 8, ''));

          return object;
        })
  };

  return ModelDefinition(model, bindings);
}

/// [Day] entity fields to define ObjectBox queries.
class Day_ {
  /// see [Day.id]
  static final id = QueryIntegerProperty<Day>(_entities[0].properties[0]);

  /// see [Day.uuid]
  static final uuid = QueryStringProperty<Day>(_entities[0].properties[1]);

  /// see [Day.date]
  static final date = QueryIntegerProperty<Day>(_entities[0].properties[2]);

  /// see [Day.dbLunchMenu]
  static final dbLunchMenu =
      QueryStringVectorProperty<Day>(_entities[0].properties[3]);

  /// see [Day.dbDinnerMenu]
  static final dbDinnerMenu =
      QueryStringVectorProperty<Day>(_entities[0].properties[4]);
}

/// [FrozenMeal] entity fields to define ObjectBox queries.
class FrozenMeal_ {
  /// see [FrozenMeal.id]
  static final id =
      QueryIntegerProperty<FrozenMeal>(_entities[1].properties[0]);

  /// see [FrozenMeal.uuid]
  static final uuid =
      QueryStringProperty<FrozenMeal>(_entities[1].properties[1]);

  /// see [FrozenMeal.name]
  static final name =
      QueryStringProperty<FrozenMeal>(_entities[1].properties[2]);

  /// see [FrozenMeal.freezingDate]
  static final freezingDate =
      QueryIntegerProperty<FrozenMeal>(_entities[1].properties[3]);

  /// see [FrozenMeal.quantity]
  static final quantity =
      QueryIntegerProperty<FrozenMeal>(_entities[1].properties[4]);

  /// see [FrozenMeal.coversType]
  static final coversType =
      QueryStringProperty<FrozenMeal>(_entities[1].properties[5]);
}

/// [History] entity fields to define ObjectBox queries.
class History_ {
  /// see [History.id]
  static final id = QueryIntegerProperty<History>(_entities[2].properties[0]);

  /// see [History.objectName]
  static final objectName =
      QueryStringProperty<History>(_entities[2].properties[1]);

  /// see [History.uuid]
  static final uuid = QueryStringProperty<History>(_entities[2].properties[2]);

  /// see [History.dateTime]
  static final dateTime =
      QueryIntegerProperty<History>(_entities[2].properties[3]);

  /// see [History.operation]
  static final operation =
      QueryStringProperty<History>(_entities[2].properties[4]);
}

/// [Ingredient] entity fields to define ObjectBox queries.
class Ingredient_ {
  /// see [Ingredient.id]
  static final id =
      QueryIntegerProperty<Ingredient>(_entities[3].properties[0]);

  /// see [Ingredient.uuid]
  static final uuid =
      QueryStringProperty<Ingredient>(_entities[3].properties[1]);

  /// see [Ingredient.name]
  static final name =
      QueryStringProperty<Ingredient>(_entities[3].properties[2]);

  /// see [Ingredient.icon]
  static final icon =
      QueryStringProperty<Ingredient>(_entities[3].properties[3]);

  /// see [Ingredient.shop]
  static final shop =
      QueryRelationToOne<Ingredient, Shop>(_entities[3].properties[4]);

  /// see [Ingredient.units]
  static final units =
      QueryRelationToMany<Ingredient, Unit>(_entities[3].relations[0]);
}

/// [Recipe] entity fields to define ObjectBox queries.
class Recipe_ {
  /// see [Recipe.id]
  static final id = QueryIntegerProperty<Recipe>(_entities[4].properties[0]);

  /// see [Recipe.uuid]
  static final uuid = QueryStringProperty<Recipe>(_entities[4].properties[1]);

  /// see [Recipe.name]
  static final name = QueryStringProperty<Recipe>(_entities[4].properties[2]);

  /// see [Recipe.defaultQuantity]
  static final defaultQuantity =
      QueryIntegerProperty<Recipe>(_entities[4].properties[3]);

  /// see [Recipe.coversType]
  static final coversType =
      QueryStringProperty<Recipe>(_entities[4].properties[4]);

  /// see [Recipe.difficultyLevel]
  static final difficultyLevel =
      QueryStringProperty<Recipe>(_entities[4].properties[5]);

  /// see [Recipe.healthinessLevel]
  static final healthinessLevel =
      QueryStringProperty<Recipe>(_entities[4].properties[6]);

  /// see [Recipe.approvalStatus]
  static final approvalStatus =
      QueryBooleanProperty<Recipe>(_entities[4].properties[7]);

  /// see [Recipe.mealTypesList]
  static final mealTypesList =
      QueryStringVectorProperty<Recipe>(_entities[4].properties[8]);

  /// see [Recipe.lastCookingDate]
  static final lastCookingDate =
      QueryIntegerProperty<Recipe>(_entities[4].properties[9]);

  /// see [Recipe.creationDate]
  static final creationDate =
      QueryIntegerProperty<Recipe>(_entities[4].properties[10]);

  /// see [Recipe.picturePaths]
  static final picturePaths =
      QueryStringVectorProperty<Recipe>(_entities[4].properties[11]);

  /// see [Recipe.dbPreparationDuration]
  static final dbPreparationDuration =
      QueryIntegerProperty<Recipe>(_entities[4].properties[12]);

  /// see [Recipe.dbCookingDuration]
  static final dbCookingDuration =
      QueryIntegerProperty<Recipe>(_entities[4].properties[13]);

  /// see [Recipe.dbBreakDuration]
  static final dbBreakDuration =
      QueryIntegerProperty<Recipe>(_entities[4].properties[14]);

  /// see [Recipe.dbSeason]
  static final dbSeason =
      QueryStringVectorProperty<Recipe>(_entities[4].properties[15]);

  /// see [Recipe.dbSectionsList]
  static final dbSectionsList =
      QueryStringVectorProperty<Recipe>(_entities[4].properties[16]);

  /// see [Recipe.tags]
  static final tags =
      QueryRelationToMany<Recipe, Tag>(_entities[4].relations[0]);
}

/// [Shop] entity fields to define ObjectBox queries.
class Shop_ {
  /// see [Shop.id]
  static final id = QueryIntegerProperty<Shop>(_entities[5].properties[0]);

  /// see [Shop.uuid]
  static final uuid = QueryStringProperty<Shop>(_entities[5].properties[1]);

  /// see [Shop.name]
  static final name = QueryStringProperty<Shop>(_entities[5].properties[2]);
}

/// [ShoppingList] entity fields to define ObjectBox queries.
class ShoppingList_ {
  /// see [ShoppingList.id]
  static final id =
      QueryIntegerProperty<ShoppingList>(_entities[6].properties[0]);

  /// see [ShoppingList.uuid]
  static final uuid =
      QueryStringProperty<ShoppingList>(_entities[6].properties[1]);

  /// see [ShoppingList.start]
  static final start =
      QueryIntegerProperty<ShoppingList>(_entities[6].properties[2]);

  /// see [ShoppingList.end]
  static final end =
      QueryIntegerProperty<ShoppingList>(_entities[6].properties[3]);

  /// see [ShoppingList.dbItemsList]
  static final dbItemsList =
      QueryStringVectorProperty<ShoppingList>(_entities[6].properties[4]);
}

/// [Tag] entity fields to define ObjectBox queries.
class Tag_ {
  /// see [Tag.id]
  static final id = QueryIntegerProperty<Tag>(_entities[7].properties[0]);

  /// see [Tag.uuid]
  static final uuid = QueryStringProperty<Tag>(_entities[7].properties[1]);

  /// see [Tag.name]
  static final name = QueryStringProperty<Tag>(_entities[7].properties[2]);
}

/// [Unit] entity fields to define ObjectBox queries.
class Unit_ {
  /// see [Unit.id]
  static final id = QueryIntegerProperty<Unit>(_entities[8].properties[0]);

  /// see [Unit.uuid]
  static final uuid = QueryStringProperty<Unit>(_entities[8].properties[1]);

  /// see [Unit.name]
  static final name = QueryStringProperty<Unit>(_entities[8].properties[2]);
}
